/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  $Id: sample1.c 2416 2012-09-07 08:06:20Z ertl-hiro $
 */

#include <kernel.h>
#include <t_syslog.h>
#include <t_stdlib.h>
#include "syssvc/serial.h"
#include "syssvc/syslog.h"
#include "kernel_cfg.h"
#include "sample1.h"


#define  DEF_TASK_WAIT   30

extern  int  _kernel_tmax_tskid;
void  disp_change_base_time( void );
void  disp_init( void );
void  disp_base( void );
void  disp_main( void );
void  dev_gpio_init( void );
void  dev_timer_init( void );
void  dev_adc_init( void );
unsigned int  dev_adc_read( void );
unsigned short int  dev_timer_clr_int( void );
unsigned short int  dev_timer_read( void );
int  scan_data_line( void );

unsigned short int  dev_gpio_c_read( void );
void  dev_gpio_a8_out( int stat );
int  dev_get_btn_stat( void );

int  out_gpio_handler_count;
int  disp_main_flag;


void  WaitMsec( int );


void  delay( int msec )
{
  tslp_tsk( msec );
}


Inline void
svc_perror(const char *file, int_t line, const char *expr, ER ercd)
{
	if (ercd < 0) {
		t_perror(LOG_ERROR, file, line, expr, ercd);
	}
}

#define	SVC_PERROR(expr)	svc_perror(__FILE__, __LINE__, #expr, (expr))


void tex_routine(TEXPTN texptn, intptr_t exinf)
{
	int_t	tskno = (int_t) exinf;

	syslog(LOG_NOTICE, "task%d receives exception 0x%04x.", tskno, texptn);

	if ((texptn & 0x8000U) != 0U) {
		syslog(LOG_INFO, "#%d#ext_tsk()", tskno);
		SVC_PERROR(ext_tsk());
		assert(0);
	}
}


/*
 *  CPU㳰ϥɥ
 */
#ifdef CPUEXC1

void
cpuexc_handler(void *p_excinf)
{
	ID		tskid;

	syslog(LOG_NOTICE, "CPU exception handler (p_excinf = %08p).", p_excinf);
	if (sns_ctx() != true) {
		syslog(LOG_WARNING,
					"sns_ctx() is not true in CPU exception handler.");
	}
	if (sns_dpn() != true) {
		syslog(LOG_WARNING,
					"sns_dpn() is not true in CPU exception handler.");
	}
	syslog(LOG_INFO, "sns_loc = %d sns_dsp = %d sns_tex = %d",
									sns_loc(), sns_dsp(), sns_tex());
	syslog(LOG_INFO, "xsns_dpn = %d xsns_xpn = %d",
									xsns_dpn(p_excinf), xsns_xpn(p_excinf));

	if (xsns_xpn(p_excinf)) {
		syslog(LOG_NOTICE, "Sample program ends with exception.");
		SVC_PERROR(ext_ker());
		assert(0);
	}

	SVC_PERROR(iget_tid(&tskid));
	SVC_PERROR(iras_tex(tskid, 0x8000U));
}

#endif /* CPUEXC1 */

/*
 *  ϥɥ
 *
 *  HIGH_PRIORITYMID_PRIORITYLOW_PRIORITY γͥ٤Υǥ塼
 *  ž롥
 */
void cyclic_handler(intptr_t exinf)
{
}

/*
 *  顼ϥɥ
 *
 *  HIGH_PRIORITYMID_PRIORITYLOW_PRIORITY γͥ٤Υǥ塼
 *  ž롥
 */
void alarm_handler(intptr_t exinf)
{
}


void task1(intptr_t exinf)
{
  syslog(LOG_NOTICE, "%s(exinf = %d).", __FUNCTION__, (int_t) exinf);

  while( 1 ) {
    tslp_tsk( DEF_TASK_WAIT );
  }
}


void task2(intptr_t exinf)
{
  syslog(LOG_NOTICE, "%s(exinf = %d).", __FUNCTION__, (int_t) exinf);

  while( 1 ) {
    tslp_tsk( DEF_TASK_WAIT );
  }
}


void task3(intptr_t exinf)
{
  syslog(LOG_NOTICE, "%s(exinf = %d).", __FUNCTION__, (int_t) exinf);

  while( 1 ) {
#if 0
    syslog(LOG_NOTICE, "0x%04x", dev_gpio_c_read() );
    tslp_tsk( 1 );
#else
    tslp_tsk( DEF_TASK_WAIT );
#endif
  }
}


void  main_timer_init( void )
{
  ER  er;

  dev_timer_init();
  out_gpio_handler_count = 0;
  disp_main_flag = 0;
  er = ena_int( 44 );

  syslog(LOG_NOTICE, "main_timer_init() er:%d", er);
}


void  main_timer_handler(void *p_excinf)
{
  dev_gpio_a8_out( out_gpio_handler_count & 0x1 );
  out_gpio_handler_count++;

  if( disp_main_flag == 0 ) {
    disp_main_flag = scan_data_line();
  }

  (void)dev_timer_clr_int();
}


void main_task(intptr_t exinf)
{
	ER_UINT	ercd;

	SVC_PERROR(syslog_msk_log(LOG_UPTO(LOG_INFO), LOG_UPTO(LOG_EMERG)));
	syslog(LOG_NOTICE, "Sample program starts (exinf = %d).", (int_t) exinf);

	ercd = serial_opn_por(TASK_PORTID);
	if (ercd < 0 && MERCD(ercd) != E_OBJ) {
		syslog(LOG_ERROR, "%s (%d) reported by `serial_opn_por'.",
									itron_strerror(ercd), SERCD(ercd));
	}
	SVC_PERROR(serial_ctl_por(TASK_PORTID,
							(IOCTL_CRLF | IOCTL_FCSND | IOCTL_FCRCV)));

	dev_gpio_init();
	dev_adc_init();
	disp_init();
	disp_base();
	main_timer_init();

	SVC_PERROR(act_tsk(TASK1));
	SVC_PERROR(act_tsk(TASK2));
	SVC_PERROR(act_tsk(TASK3));

	SVC_PERROR(sta_cyc(CYCHDR1));

	syslog(LOG_NOTICE, "%s() _kernel_tmax_tskid=%d", __FUNCTION__, _kernel_tmax_tskid);

	/*
	 *  ᥤ롼
	 */
	do {
		if( disp_main_flag ) {
			disp_main();
			disp_main_flag = 0;
		}
		disp_change_base_time();
		tslp_tsk( 10 );
		//syslog(LOG_NOTICE,"TIM2->CNT:0x%04x", dev_timer_read() );
		//syslog(LOG_NOTICE,"ADC1->DR:0x%08x", dev_adc_read() );

	} while( 1 );

	syslog(LOG_NOTICE, "Sample program ends.");
	SVC_PERROR(ext_ker());
	assert(0);
}
